from kivy.uix.boxlayout import BoxLayout
from kivy.app import App
from kivy.lang import Builder
from kivy.uix.label import Label
from kivy.clock import Clock

customItemNumber = 0
markupFactor = 1.2


class StoreItem:
    itemID = "unknown"
    name = "unknown"
    cost = 0.00
    price = 0.00

    def __init__(self, newCost=None, newName=None, UPC=None):
        global customItemNumber
        global markupFactor
        if newCost is not None:
            self.cost = newCost
        if newName is not None:
            self.name = newName
        if UPC is not None:
            self.itemID = UPC
        else:
            self.itemID = str(customItemNumber)
            customItemNumber = customItemNumber + 1
        self.price = self.cost * markupFactor
        self.price = round(self.price, 2)

inventoryList = list()

inventoryList.append(StoreItem(newCost=2.00, newName="Bread", UPC="10009999"))
inventoryList.append(StoreItem(newCost=.83, newName="MYBRAND Napkins", UPC="44440001"))
#Since we are using python, you do not have to have all of the parameters:
inventoryList.append(StoreItem(newCost=.68, newName="Apple"))
inventoryList.append(StoreItem(newCost=.50, UPC="12340001"))
inventoryList.append(StoreItem(newCost=3.00))


Builder.load_string('''
<Form1>:
    cols: 1
    BoxLayout:
        orientation: 'vertical'
        GridLayout:
            id: inventoryGridLayout
            size_hint: 1.0, 0.3
            cols: 3
        TextInput:
            size_hint: 1.0, 0.1
            id: itemTextInput
        Button:
            size_hint: 1.0, 0.1
            id: addButton
            text: 'Add To Cart'
            on_press:root.addClick()
        ListView:
            id: cartListView
            size_hint: 1.0,0.3
        Label:
            id: subtotalLabel
            size_hint: 1.0,0.1
            text:"SUBTOTAL"
        Label:
            id: totalLabel
            size_hint: 1.0,0.05
            text:"TOTAL"
        Label:
            id: statusLabel
            size_hint: 1.0,0.05
''')


class Form1(BoxLayout):
    subtotal = 0.00
    total = 0.00
    salestaxRate = 0.06
    cart = list()

    def form1Load(self):
        global inventoryList
        for thisItem in inventoryList:
            self.ids.inventoryGridLayout.add_widget(Label(text=thisItem.itemID))
            self.ids.inventoryGridLayout.add_widget(Label(text=thisItem.name))
            self.ids.inventoryGridLayout.add_widget(Label(text=str(thisItem.price)))

    def addClick(self):
        self.ids.cartListView.item_strings.append(self.ids.itemTextInput.text)


class ShoppingCartApp(App):
    def build(self):
        form = Form1()
        form.form1Load()
        return form

if __name__ == '__main__':
    ShoppingCartApp().run()

